package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.ProductCommentImage;
import com.izouma.awesomeadmin.service.ProductCommentImageService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/productCommentImage")
@RequiresAuthentication
public class ProductCommentImageController {

    @Autowired
    private ProductCommentImageService productCommentImageService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(ProductCommentImage record) {
        List<ProductCommentImage> pp = productCommentImageService.getProductCommentImageList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getProductCommentImage", method = RequestMethod.GET)
    @ResponseBody
    public Result getProductCommentImage(@RequestParam(required = false, value = "id") String id) {
        ProductCommentImage data = productCommentImageService.getProductCommentImageById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(ProductCommentImage record) {
        ProductCommentImage data = productCommentImageService.getProductCommentImage(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, ProductCommentImage record) {
        Map<String, Object> result = new HashMap<>();

        List<ProductCommentImage> pp =productCommentImageService.getProductCommentImageByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(ProductCommentImage record) {
        boolean num = productCommentImageService.createProductCommentImage(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateProductCommentImage(ProductCommentImage record) {
        boolean num = productCommentImageService.updateProductCommentImage(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteProductCommentImage(@RequestParam(required = true, value = "id") String id) {

        boolean num = productCommentImageService.deleteProductCommentImage(id);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, ProductCommentImage record) throws Exception {

    List<ProductCommentImage> productCommentImages = productCommentImageService.getProductCommentImageList(record);


        String sheetName = "product_comment_image";
        String titleName = "商品评论图片数据表";
        String fileName = "商品评论图片表";
        int columnNumber = 13;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20 };
        String[] columnName = {  "" ,   "删除标识" ,   "更新时间" ,   "更新人" ,   "创建时间" ,   "创建人" ,   "商品" ,   "订单" ,   "用户" ,   "店铺" ,   "评论" ,   "图片" ,   "大小"  };
        String[][] dataList = new String[productCommentImages.size()][13];

        for (int i = 0; i < productCommentImages.size(); i++) {

                        dataList[i][0] = String.valueOf(productCommentImages.get(i).getId());
                        dataList[i][1] = String.valueOf(productCommentImages.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(productCommentImages.get(i).getUpdateTime());
                        dataList[i][3] = String.valueOf(productCommentImages.get(i).getUpdateUser());
                        dataList[i][4] = String.valueOf(productCommentImages.get(i).getCreateTime());
                        dataList[i][5] = String.valueOf(productCommentImages.get(i).getCreateUser());
                        dataList[i][6] = String.valueOf(productCommentImages.get(i).getProductId());
                        dataList[i][7] = String.valueOf(productCommentImages.get(i).getOrderId());
                        dataList[i][8] = String.valueOf(productCommentImages.get(i).getUserId());
                        dataList[i][9] = String.valueOf(productCommentImages.get(i).getStoreId());
                        dataList[i][10] = String.valueOf(productCommentImages.get(i).getCommentId());
                        dataList[i][11] = String.valueOf(productCommentImages.get(i).getImageUrl());
                        dataList[i][12] = String.valueOf(productCommentImages.get(i).getImageSize());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

